﻿var Vevo = Vevo || {};

Vevo.Temp = function () {
    this.trackComScore = function (c1, c2, c3, c4, c5, c6) {
        /*var page = document.location.href;
        var referrer = document.referrer;
        var title = document.title;

        if (page != null && page.length > 512) { page = page.substr(0, 512); }
        if (referrer.length > 512) { referrer = referrer.substr(0, 512); }

        $.ajax("http://b.scorecardresearch.com/p",
        { data: { c1: c1,
        c2: c2,
        c3: c3,
        c4: c4,
        c5: c5,
        c6: c6,
        c7: escape(page),
        c8: escape(title),
        c9: escape(referrer),
        rn: Math.random(),
        cv: "2.0"
        }
        });*/
    };

    var generateUrl = function (extraKeys) {
        var newPath = comscore_tracking_path;

        if (extraKeys) {
            extraKeys['ns_type'] = 'hidden';

            $.each(extraKeys, function (k, v) {
                newPath += "&" + k + "=" + encodeURIComponent(v);
            });
        }

        return newPath;
    };

    this.trackAjaxDaxComScore = function (extraKeys, complete) {
        if (typeof comscore_tracking_path !== 'string') {
            if (complete) complete();
            return;
        };

        var newPath = generateUrl(extraKeys);

        // get the comscore endpoint
        newPath = udm_url(newPath);

        $.ajax({timeout: 2000,
                url: newPath,
                type: "GET", 
                xhrFields: {
                    withCredentials: true
                }
        }).always(function () {
            if (complete) complete();
        });
    };

    this.trackPageLoad = function (extraKeys) {
        if (typeof comscore_tracking_path !== 'string') return;

        var parts = comscore_tracking_path.split('?');

        var vals = parts[1].split('&');
        var params = {};
        $.each(vals, function (idx, val) {
            var p = val.split('=');
            params[p[0]] = p[1];
        });

        if (extraKeys) {
            $.each(extraKeys, function (k, v) {
                params[k] = encodeURIComponent(v);
            });
        }

        var queryPart = '';
        var first = 0;

        // re-construct the url
        $.each(params, function (k, v) {
            queryPart += ((first++) ? '&' : '?') + k + "=" + v;
        });

        // assign it as our new base
        comscore_tracking_path = parts[0] + queryPart;        

        // update stream sense
        if (typeof ns_ !== 'undefined') {
            // setup a new base
            var streamTrackingBase = udm_url(comscore_tracking_path).replace(/&ns__t=\d+/, "");

            // update the url
            ns_.StreamSense.getStreamSense().setPixelURL(streamTrackingBase);
        }

        // track it
        udm_(comscore_tracking_path);
    };

    this.trackImageDaxComScore = function (extraKeys) {
        if (typeof comscore_tracking_path !== 'string') return;

        var newPath = generateUrl(extraKeys);
        udm_(newPath);
    };

    this.trackBackButton = function (extraKeys) {
        if (typeof comscore_tracking_path !== 'string') return;

        this.trackAjaxDaxComScore(extraKeys, function () {
            history.go(-1);
        });
    };
};

Vevo.Temp =
{
	ComScore: new Vevo.Temp()
}
///extend vevo object
var tmp = $.extend(false, Vevo.Tracking, Vevo.Temp);
Vevo.Tracking = tmp;
Vevo.Temp = null;
