﻿Vevo.Temp = function () {
	this.contentVideoURL = "";
	this.theAdManager = {};
	this.theContext = {};
	this.preLoadAdData = false;
	this.prerollSlots = [];
	this.adDataRequested = false;
	this.midroll_overlaySlots = [];
	this.postrollSlots = [];
	this.slotPlaying = false;
	this.preRollPlaying = false;
	this.theVideoAssetId = "";
	this.initCallback = null;
	this.requestTimeout = false;
	this.init = function (theSiteSectionId, callback) {
		Vevo.HTML5.Freewheel.contentVideoURL = $('#videoPlayer')[0].src;
		//Parameters for FreeWheel JSAM (JavaScript AdManager)
		//var theNetworkId = 96749;
		//var theServerURL = "http://sdnyadvip1-d.fwmrm.net/ad/g/1";
		var theNetworkId = 40185;
		var theServerURL = "http://9cf9.v.fwmrm.net/ad/g/1";
		var theDisplayBaseId = "playerHTML5";
		var theProfileId = "vevo_HTML5_prod";
		Vevo.HTML5.Freewheel.theVideoAssetId = Vevo.Views.Watch.CurrentVideo.ISRC;
		var theVideoDuration = Vevo.Views.Watch.authData.video.duration;

		$('#videoPlayer').unbind('timeupdate', Vevo.HTML5.Freewheel.onContentVideoTimeUpdated);
		$('#videoPlayer').unbind('ended', Vevo.HTML5.Freewheel.onContentVideoEnded);

		if (typeof tv == 'undefined') {
			Vevo.Helpers.Console.Log('freewheel not found');
			return;
		}

		Vevo.HTML5.Freewheel.theAdManager = new tv.freewheel.SDK.AdManager();
		Vevo.HTML5.Freewheel.theAdManager.setNetwork(theNetworkId);
		Vevo.HTML5.Freewheel.theAdManager.setServer(theServerURL);
		Vevo.HTML5.Freewheel.theContext = Vevo.HTML5.Freewheel.theAdManager.newContext();
		Vevo.HTML5.Freewheel.theContext.registerVideoDisplayBase(theDisplayBaseId);
		Vevo.HTML5.Freewheel.theContext.setProfile(theProfileId);
		Vevo.HTML5.Freewheel.theContext.setVideoAsset(Vevo.HTML5.Freewheel.theVideoAssetId, theVideoDuration, theNetworkId);
		Vevo.HTML5.Freewheel.theContext.setSiteSection(theSiteSectionId, theNetworkId);

		//Add key-values for ad targeting.
		//theContext.addKeyValue("module", "DemoPlayer");
		//theContext.addKeyValue("feature", "trackingURLs");
		//theContext.addKeyValue("feature", "simpleAds");

		//Listen to AdManager Events
		Vevo.HTML5.Freewheel.initCallback = callback;
		Vevo.HTML5.Freewheel.theContext.addEventListener(tv.freewheel.SDK.EVENT_REQUEST_COMPLETE, Vevo.HTML5.Freewheel.onRequestComplete);
		Vevo.HTML5.Freewheel.theContext.addEventListener(tv.freewheel.SDK.EVENT_SLOT_ENDED, Vevo.HTML5.Freewheel.onSlotEnded);

		//To make sure video ad playback in poor network condition, set video ad timeout parameters.
		Vevo.HTML5.Freewheel.theContext.setParameter(tv.freewheel.SDK.PARAMETER_RENDERER_VIDEO_START_DETECT_TIMEOUT, 10000, tv.freewheel.SDK.PARAMETER_LEVEL_GLOBAL);
		Vevo.HTML5.Freewheel.theContext.setParameter(tv.freewheel.SDK.PARAMETER_RENDERER_VIDEO_PROGRESS_DETECT_TIMEOUT, 10000, tv.freewheel.SDK.PARAMETER_LEVEL_GLOBAL);

		//Add 1 preroll, 1 midroll, 2 overlay, 1 postroll slot
		Vevo.HTML5.Freewheel.theContext.addTemporalSlot("Preroll_1", tv.freewheel.SDK.ADUNIT_PREROLL, 0);
		//this.theContext.addTemporalSlot("Midroll_1", tv.freewheel.SDK.ADUNIT_MIDROLL, 5);
		//this.theContext.addTemporalSlot("Overlay_1", tv.freewheel.SDK.ADUNIT_OVERLAY, 10);
		//this.theContext.addTemporalSlot("Overlay_2", tv.freewheel.SDK.ADUNIT_OVERLAY, 15);
		//this.theContext.addTemporalSlot("Postroll_1", tv.freewheel.SDK.ADUNIT_POSTROLL, 60);
		//Conviva.LivePass.init("http://livepass.conviva.com", "c3.Vevo", Vevo.HTML5.Conviva.livePassNotifier);

		Vevo.HTML5.Freewheel.preRollPlaying = false;
		Vevo.HTML5.Freewheel.requestTimeout = false;
		Vevo.HTML5.Freewheel.loadAdData();
		
		setTimeout(Vevo.HTML5.Freewheel.handleRequestTimeout, 15000); //don't prevent user from playing video if ad call fails
	};
	this.handleRequestTimeout = function () {
		if (!Vevo.HTML5.Freewheel.requestTimeout) {
			Vevo.HTML5.Freewheel.initCallback();
		}
		Vevo.HTML5.Freewheel.requestTimeout = true;
	};
	this.loadAdData = function () {
		Vevo.HTML5.Freewheel.loadAdData();
	};
	this.playPreRoll = function () {
		if (Vevo.HTML5.Freewheel.prerollSlots && Vevo.HTML5.Freewheel.prerollSlots[0]) {
			if (typeof ns_ !== 'undefined') {
				// turn off stream tracking                
				ns_.StreamSense.getStreamSense().getPlayer().deactivate();
			}

			Vevo.HTML5.Freewheel.prerollSlots[0].play();
			Vevo.HTML5.Freewheel.preRollPlaying = true;
			return true;
		}

		Vevo.HTML5.Freewheel.preRollPlaying = false;
		return false;
	};
	this.onRequestComplete = function (event) {
		Vevo.Helpers.Console.Log("onRequestComplete");

		if (Vevo.HTML5.Freewheel.requestTimeout) {
			return;
		}
		Vevo.HTML5.Freewheel.requestTimeout = true;

		
		if (event.success) {
			//this.theContext = event.target;
			var fwTemporalSlots = Vevo.HTML5.Freewheel.theContext.getTemporalSlots();
			for (var i = 0; i < fwTemporalSlots.length; i++) {
				var slot = fwTemporalSlots[i];
				switch (slot.getTimePositionClass()) {
					case tv.freewheel.SDK.TIME_POSITION_CLASS_PREROLL:
						Vevo.HTML5.Freewheel.prerollSlots.push(slot);
						break;
					case tv.freewheel.SDK.TIME_POSITION_CLASS_MIDROLL:
					case tv.freewheel.SDK.TIME_POSITION_CLASS_OVERLAY:
						Vevo.HTML5.Freewheel.midroll_overlaySlots.push(slot);
						break;
					case tv.freewheel.SDK.TIME_POSITION_CLASS_POSTROLL:
						Vevo.HTML5.Freewheel.postrollSlots.push(slot);
						break;
				}
			}
		}
		
		Vevo.HTML5.Freewheel.initCallback();
		
	};
	this.onSlotEnded = function (event) {
		var slotTimePositionClass = event.slot.getTimePositionClass();
		Vevo.Helpers.Console.Log("onSlotEnded slotTimePositionClass: " + slotTimePositionClass);
		switch (slotTimePositionClass) {
			case tv.freewheel.SDK.TIME_POSITION_CLASS_PREROLL:
				if (Vevo.HTML5.Freewheel.prerollSlots.length) {
					Vevo.HTML5.Freewheel.prerollSlots.shift();
					if (Vevo.HTML5.Freewheel.prerollSlots.length) {
						Vevo.HTML5.Freewheel.initCallback();
					} else {

						if (typeof ns_ !== 'undefined') {
							// turn back on stream tracking
						    ns_.StreamSense.getStreamSense().getPlayer().activate(document.getElementById('videoPlayer'));
						}

						$('#videoPlayer').bind('ended', Vevo.HTML5.Freewheel.onContentVideoEnded);
						$('#videoPlayer').bind('timeupdate', Vevo.HTML5.Freewheel.onContentVideoTimeUpdated);
						$('#videoPlayer')[0].play();
						Vevo.HTML5.Freewheel.preRollPlaying = false;
						Vevo.HTML5.Freewheel.theContext.setVideoState(tv.freewheel.SDK.VIDEO_STATE_PLAYING);
						//Vevo.Helpers.Analytics.trackEvent("VideoPlayerHtml5", "PlaybackBegin", Vevo.HTML5.Freewheel.theVideoAssetId);
						//Vevo.Helpers.Analytics.trackSuperBeacon("SOURCE_ID", Vevo.HTML5.Freewheel.theVideoAssetId, "0", "www.vevo.com", "", "en-US");
						//Vevo.HTML5.Conviva.beginMonitoringSession();
					}
				}
				break;
			case tv.freewheel.SDK.TIME_POSITION_CLASS_MIDROLL:
			case tv.freewheel.SDK.TIME_POSITION_CLASS_OVERLAY:
				Vevo.HTML5.Freewheel.slotPlaying = false;
				Vevo.HTML5.Freewheel.preRollPlaying = false;
				break;
			case tv.freewheel.SDK.TIME_POSITION_CLASS_POSTROLL:
				if (postrollSlots.length) {
					Vevo.HTML5.Freewheel.postrollSlots.shift();
					if (Vevo.HTML5.Freewheel.postrollSlots && Vevo.HTML5.Freewheel.postrollSlots.length) {
						Vevo.HTML5.Freewheel.initCallback();
					} else {
						Vevo.HTML5.Freewheel.theContext.setVideoState(tv.freewheel.SDK.VIDEO_STATE_COMPLETED);
						Vevo.HTML5.Freewheel.preRollPlaying = false;
					}
				}
				break;
		}
	};
	this.onContentVideoEnded = function () {
		Vevo.Helpers.Console.Log("onContentVideoEnded");
		$('#videoPlayer').unbind('timeupdate', Vevo.HTML5.Freewheel.onContentVideoTimeUpdated);
		$('#videoPlayer').unbind('ended', Vevo.HTML5.Freewheel.onContentVideoEnded);
		Vevo.HTML5.Freewheel.theContext.setVideoState(tv.freewheel.SDK.VIDEO_STATE_STOPPED);

		Vevo.HTML5.Freewheel.theContext.setVideoState(tv.freewheel.SDK.VIDEO_STATE_COMPLETED);
	};
	this.onContentVideoTimeUpdated = function () {
		if (!Vevo.HTML5.Freewheel.midroll_overlaySlots.length) {
			$('#videoPlayer').unbind('timeupdate', Vevo.HTML5.Freewheel.onContentVideoTimeUpdated);
			return;
		}

		for (var i = 0; i < Vevo.HTML5.Freewheel.midroll_overlaySlots.length; i++) {
			var slot = Vevo.HTML5.Freewheel.midroll_overlaySlots[i];
			var slotTimePosition = slot.getTimePosition();
			var videoCurrentTime = $('#videoPlayer')[0].currentTime;

			if (videoCurrentTime - slotTimePosition >= 0 && videoCurrentTime - slotTimePosition <= 1 && !Vevo.HTML5.Freewheel.slotPlaying) {
				Vevo.HTML5.Freewheel.slotPlaying = true;
				Vevo.HTML5.Freewheel.midroll_overlaySlots.splice(i, 1);
				Vevo.Helpers.Console.Log("onContentVideoTimeUpdated timePositionClass: " + slot.getTimePositionClass());
				slot.play();
				Vevo.HTML5.Freewheel.preRollPlaying = true;
				return;
			}
		}
	};
	this.log = function (msg) {
		if (window.console) {
			window.console.log('[HTML5 Player] ' + msg);
		}
	};
	this.startPlayback = function () {
		Vevo.Helpers.Console.Log("start");
		Vevo.Helpers.Analytics.trackEvent("VideoPlayerHtml5", "PlaybackBegin", Vevo.HTML5.Freewheel.theVideoAssetId);
		Vevo.Helpers.Analytics.trackSuperBeacon("SOURCE_ID", Vevo.HTML5.Freewheel.theVideoAssetId, "0", "www.vevo.com", "", "en-US");
		if (!adDataRequested) {
			Vevo.HTML5.Freewheel.loadAdData();
		} else {
			if (Vevo.HTML5.Freewheel.prerollSlots.length) {
				Vevo.HTML5.Freewheel.initCallback();
			}
		}
	};
	this.loadAdData = function () {
		this.theContext.submitRequest();
		this.adDataRequested = true;
	};
};

Vevo.Temp =
{
	Freewheel: new Vevo.Temp()
}
///extend vevo object
var tmp = $.extend(false, Vevo.HTML5, Vevo.Temp);
Vevo.HTML5 = tmp;
Vevo.Temp = null;
